package goap

type LitepubCapabilitiesData struct {
	Next         BaseApChain
	Capabilities []map[string]any
}

func (capabilitiesdata *LitepubCapabilitiesData) GetSelfOrBase() (BaseApChain, bool) {
	return capabilitiesdata.Next, true
}

func (capabilitiesdata *LitepubCapabilitiesData) MarshalToMap() map[string]any {
	return appendWithKey(
		capabilitiesdata.Next.MarshalToMap(),
		KEY_LITEPUB_CAPABILITIES,
		capabilitiesdata.Capabilities,
	)
}

type LitepubOauthRegistrationEndpointData struct {
	FullIdType
}

func (oauthregistrationendpointdata *LitepubOauthRegistrationEndpointData) GetSelfOrBase() (BaseApChain, bool) {
	return oauthregistrationendpointdata.FullIdType.GetSelfOrBase()
}

func (oauthregistrationendpointdata *LitepubOauthRegistrationEndpointData) MarshalToMap() map[string]any {
	return oauthregistrationendpointdata.FullIdType.MarshalToMapWithName(
		KEY_ACTIVITYSTREAMS_OAUTHAUTHORIZATION,
	)
}
