package goap

// NOTE: Different to ASSummaryData
// Misskey summary is the raw text without formatting applied while the Activitystreams summary already contains the preformatted summary
type MKSummaryData struct {
	Next    BaseApChain
	Summary string
}

func (misskeysummarydata *MKSummaryData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *MKSummaryData) MarshalToMap() map[string]any {
	return appendWithKey(
		misskeysummarydata.Next.MarshalToMap(),
		KEY_MISSKEY_MKSUMMARY,
		[]map[string]any{{KEY_VALUE: misskeysummarydata.Summary}},
	)
}

type MKIsCatData struct {
	Next  BaseApChain
	IsCat bool
}

func (iscatdata *MKIsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *MKIsCatData) MarshalToMap() map[string]any {
	return appendWithKey(
		iscatdata.Next.MarshalToMap(),
		KEY_MISSKEY_ISCAT,
		[]map[string]any{{KEY_VALUE: iscatdata.IsCat}},
	)
}

type MKSpeakAsCatData struct {
	Next        BaseApChain
	SpeaksAsCat bool
}

func (iscatdata *MKSpeakAsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *MKSpeakAsCatData) MarshalToMap() map[string]any {
	return appendWithKey(
		iscatdata.Next.MarshalToMap(),
		KEY_FIREFISH_SPEAKASCAT,
		[]map[string]any{{KEY_VALUE: iscatdata.SpeaksAsCat}},
	)
}
